//
//  AppDelegate.swift
//  BookList
//
//  Created by Natsuko Nishikata on 2015/12/09.
//  Copyright © 2015年 Natsuko Nishikata. All rights reserved.
//

import UIKit
import CoreData

@UIApplicationMain
class AppDelegate: UIResponder, UIApplicationDelegate {

    var window: UIWindow?


    func application(application: UIApplication, didFinishLaunchingWithOptions launchOptions: [NSObject: AnyObject]?) -> Bool {
        
        let coreDataStack:CoreDataStack = CoreDataStack()
        coreDataStack.addPersistentStoreWithCompletionHandler() {
            
        /* 
            // KVCによる属性へのアクセス
            
            // Bookオブジェクトを生成
            let book =
            NSEntityDescription.insertNewObjectForEntityForName("Book",
                inManagedObjectContext: coreDataStack.context)
            
            // title, author属性に値をセット
            book.setValue("Hamlet", forKey: "title")
            book.setValue("Shakespeare", forKey: "author")
            
            // title, author属性の値を取得
            let title = book.valueForKey("title") as! String
            let author = book.valueForKey("author") as! String

       */
            
            // アクセサメソッドを用いた属性へのアクセス
            // （カスタム管理オブジェクトクラスBookを利用）
            
            let book =
            NSEntityDescription.insertNewObjectForEntityForName("Book",
                inManagedObjectContext: coreDataStack.context) as! Book
            
            // title, author属性に値をセット
            book.title = "Hamlet"
            book.author = "Shakespeare"
            
            // title, author属性の値を取得
            let title = book.title!
            let author = book.author!
            
            print("title=\(title), author=\(author)")
            print("registeredDate=\(book.registeredDate!)")
        }
        
        return true
    }

    func applicationWillResignActive(application: UIApplication) {
        // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
        // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
    }

    func applicationDidEnterBackground(application: UIApplication) {
        // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later.
        // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
    }

    func applicationWillEnterForeground(application: UIApplication) {
        // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
    }

    func applicationDidBecomeActive(application: UIApplication) {
        // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
    }

    func applicationWillTerminate(application: UIApplication) {
        // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
    }


}

