//
//  Book.swift
//  BookList
//
//  Created by Natsuko Nishikata on 2015/12/09.
//  Copyright © 2015年 Natsuko Nishikata. All rights reserved.
//

import Foundation
import CoreData


class Book: NSManagedObject {

    
    override func awakeFromInsert() {
        // 最初に必ずsuperをコール
        super.awakeFromInsert()
        // 内部的な変更なのでプリミティブアクセサを使用
        setPrimitiveValue(NSDate(), forKey: "registeredDate")
    }
    
    var recently:NSNumber? {
        let cal = NSCalendar.currentCalendar()
        
        // 1ヶ月前の日付オブジェクト
        let oneMonthAgo =
        cal.dateByAddingUnit(NSCalendarUnit.Month,
            value: -1,
            toDate: NSDate(),
            options:NSCalendarOptions.WrapComponents)!
        
        // 登録日と1ヶ月前の日付を比較し、登録日の方が新しければ「recent」とする
        let date = primitiveValueForKey("registeredDate") as! NSDate
        if cal.compareDate(date,
            toDate: oneMonthAgo,
            toUnitGranularity: NSCalendarUnit.Day)
            == NSComparisonResult.OrderedDescending {
                return true
        } else {
            return false
        }
    }

}
